#ifndef __WANCORE_CMS_GET_API_H__
#define __WANCORE_CMS_GET_API_H__

#if defined(__cplusplus)
extern "C" {
#endif

/*!
  \brief ȡWANЭAPI
  \param[in]  pszPath: WAN·   
  \param[in]  pulProtocol: ЭATP_WAN_PROTOCOL_EN
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetProtocol(VOS_CHAR* pszPath, VOS_UINT32* pulProtocol);

#ifdef SUPPORT_ATP_MTU
/*!
  \brief ȡWANMTUAPI
  \param[in]  pszPath: WAN·
  \param[in]  pulWanMtu: Mtuֵ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetIpMtu(const VOS_CHAR* pszPath, VOS_UINT32* pulWanMtu);
#endif

#ifdef SUPPORT_ATP_TCP_MSS
/*!
  \brief ȡWANӶӦMSS API
  \param[in]  pszPath: WAN·
  \param[in]  pulMss: MSSֵ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetMSS(VOS_CHAR* pszPath, VOS_UINT32* pulMss);
#endif

/*!
  \brief ȡWANAPI
  \param[in]  pszPath: WAN·
  \param[in]  ulIntAliasLen: 
  \param[out]  pszIntAlias: WAN
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetConnInterfaceAlias(VOS_CHAR* pszPath, VOS_UINT32 ulIntAliasLen, VOS_CHAR* pszIntAlias);

/*!
  \brief ȡWANAPI
  \param[in]  pszPath: WAN·
  \param[in]  pulConnType: ATP_WAN_CONNTYPE_EN
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetConnType(VOS_CHAR* pszPath, VOS_UINT32* pulConnType);

/*!
  \brief ȡWANӳصķ
  \param[in]  pszPath: WAN·
  \param[in]  pulServiceList:  ATP_WAN_SERVICE_EN
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetServiceList(const VOS_CHAR* pszPath, VOS_UINT32* pulServiceList);

/*!
  \brief ȡWANʹܿAPI
  \param[in]  pszPath: WAN·
  \param[in]  pucEnable: Ƿʹ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetServiceEnable(VOS_CHAR* pszPath, VOS_UINT8* pucEnable);

/*!
  \brief ȡWANNATʹܿAPI
  \param[in]  pszPath: WAN·
  \param[in]  pucNatEnable: NATǷʹ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetNatEnable(VOS_CHAR* pszPath, VOS_UINT8* pucNatEnable);

/*!
  \brief ȡWAN״̬API
  \param[in]  pszPath: WAN·
  \param[in]  pulStatus: WAN״̬ATP_WAN_STATUS_EN
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetStatus(VOS_CHAR* pszPath, VOS_UINT32* pulStatus);

#ifdef SUPPORT_ATP_IPV6
/*!
  \brief ȡWAN״̬API
  \param[in]  pszPath: WAN·
  \param[in]  pulStatus: WAN״̬ATP_WAN_STATUS_EN
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetStatus6(VOS_CHAR* pszPath, VOS_UINT32* pulStatus);
#endif

/*!
  \brief ȡWANĽӿAPI
  \param[in]  pszPath: WAN·
  \param[in]  ulIfcLen:  ӿATP_WAN_IFC_LEN
  \param[in]  pszInterface: WANӿ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetInterface(const VOS_CHAR* pszPath, VOS_UINT32 ulIfcLen, VOS_CHAR* pszInterface);

/*!
  \brief ȡWANĽӿIPַ
  \param[in]  pszPath: WAN·
  \param[in]  ulAddrLen: ӿIPATP_WAN_ADDR_LEN
  \param[in]  pszIpAddr: WANӿIPַ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetIpAddr(const VOS_CHAR* pszPath, VOS_UINT32 ulAddrLen, VOS_CHAR* pszIpAddr);

/* start of AU4D00713 by d00107688 VPN޷pingͨVPNԶ˵ַ */

/*!
  \brief ȡWANĽӿĬغ
  \param[in]  pszPath: WAN·
  \param[in]  ulSubMaskLen: 볤ATP_WAN_ADDR_LEN
  \param[in]  *pszSubMask: WANӿ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetMask(VOS_CHAR* pszPath, VOS_UINT32 ulSubMaskLen, VOS_CHAR *pszSubMask);
/* end of AU4D00713 by d00107688 VPN޷pingͨVPNԶ˵ַ */

/*!
  \brief ȡWANĽӿĬ
  \param[in]  pszPath: WAN·
  \param[in]  ulGateWayLen: ĬسATP_WAN_ADDR_LEN
  \param[in]  pszGateWay: WANӿĬ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetGateWay(VOS_CHAR* pszPath, VOS_UINT32 ulGateWayLen, VOS_CHAR* pszGateWay);

/*!
  \brief ȡWANĽӿDNSַ
  \param[in]  pszPath: WAN·
  \param[in]  ulDnsLen: DNSַATP_WAN_ADDR_LEN
  \param[in]  pszPrimaryDns: һDNSַ
  \param[in]  pszSecondDns:  ڶDNSַ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetDns(VOS_CHAR* pszPath, VOS_UINT32 ulDnsLen, VOS_CHAR* pszPrimaryDns, VOS_CHAR* pszSecondDns);

/*!
  \brief ȡWANнӿڱͳϢ
  \param[in]  ulWdInstId: һʵ 
  \param[in]  pstStats:  WANнӿշ
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetStatistics(VOS_UINT32 ulWdInstId, ATP_WAN_STATS_ST* pstStats);

/*!
  \brief УWAN·ǷϷ
  \param[in]  pszPath: WAN·
  \return VOS_BOOL
  \retval ɹVOS_FALSEʧVOS_FALSE
*/
VOS_BOOL ATP_WAN_ValidatePath(VOS_CHAR* pszPath);

/*!
  \brief ȡATMWANʵ
  \param[in]  pszPath: WAN·
  \param[in]  pulWdInstId: һDEVʵŹ̶Ϊ1
  \param[in]  pulWcdInstId: ڶATMʵ
  \param[in]  pulWanInstId: WANʵ
  \param[in]  pulWanCmoId: WANʵCMO
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetInstIdByPath(VOS_CHAR* pszPath, VOS_UINT32* pulWdInstId, VOS_UINT32* pulWcdInstId, VOS_UINT32* pulWanInstId, VOS_UINT32* pulWanCmoId);

/*!
  \brief ݽӿȡWANӿPath
  \param[in]  pacWanInterface: WAN ӿ
  \param[in]  pszPath: WANӿ Path
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
#ifndef SUPPORT_ATP_TR181
VOS_UINT32 ATP_WAN_GetPathByInterface(const VOS_CHAR* pacWanInterface, VOS_CHAR* pszPath);
#else
//TR181صcmsûбpszPathȫֱ޷ֱӷָȫָ룬ҪAPIʽ
VOS_UINT32 ATP_WAN_GetPathByInterface(const VOS_CHAR* pacWanInterface, VOS_CHAR* pszPath, VOS_UINT32 ulLen);
#endif

/*!
  \brief WAN·WANʵ
  \param[in]  pszPath: WAN·
  \return ATP_WAN_INFO_ST*
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
ATP_WAN_INFO_ST* ATP_WAN_GetInstanceByPath(const VOS_CHAR* pszPath);

/*!
  \brief ˺ݹWAN·WANʵWAN·ǲ
        ʹԭʼATP_WAN_GetInstanceByPath
  \param[in]  pszPath: WAN·
  \return ATP_WAN_INFO_ST*
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
ATP_WAN_INFO_ST* ATP_WAN_GetInstanceByRefPath(const VOS_CHAR* pszPath);


/*!
  \brief WANͷָ
  \param[in] VOS_VOID: 
  \return ATP_WAN_INFO_ST*
  \retval WANṹָ
*/
ATP_WAN_INFO_ST* ATP_WAN_GetInstanceHeader(VOS_VOID);

/*!
  \brief Wanpath ȡӦWANĽڵʵԼCMO
  \param[in]  pszPath: WAN·
  \param[in]  *pulKeyList: idб
  \param[in]  *pulWanCmo: WAN CMO
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetInstList(VOS_CHAR* pszPath,  VOS_UINT32 *pulKeyList, VOS_UINT32 *pulWanCmo);

/*!
  \brief ȡACSϢ
  \param[in]  pstCurrentWanForACS: Ϣṹ
  \return 
*/
void ATP_WAN_GetACSInfo(CurrentWanForACS * pstCurrentWanForACS);

VOS_UINT32 ATP_WAN_GetLinkName(VOS_UINT32 ulWdInstId, VOS_UINT32 ulWcdInstId, 
    VOS_CHAR* pszName, VOS_UINT32 ulLen);

/*!
  \brief ȡ豸
  \param[in]  ulWdInstId: 豸ʵID
  \return VOS_UINT32豸
  \retval 
*/
VOS_UINT32 ATP_WAN_GetDeviceType(VOS_UINT32 ulWdInstId);

/*!
  \brief WANͻȡWANDevice.{i}ʵ
  \param[in]  *pcWanTypeString: 
  \param[in]  *pulWandevInstId: 
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetWanDevInstIdByWanType(const VOS_CHAR *pcWanTypeString, VOS_UINT32 *pulWandevInstId);

ATP_WAN_INFO_ST* ATP_WAN_GetWanNext(const ATP_WAN_INFO_ST* pstWan);
/*!
  \brief WAN
  \param[in]  pulIndex: WANţʼΪ0
  \param[in]  ulPathLen: WAN·ATP_WAN_PATH_LEN
  \param[in]  pszPath: WAN·
  \return VOS_UINT32
  \retval ɹVOS_OKʧATP_ERR_WAN_EN
*/
VOS_UINT32 ATP_WAN_GetNext(VOS_UINT32* pulIndex, VOS_UINT32 ulPathLen, VOS_CHAR* pszPath);
VOS_UINT32 ATP_WAN_GetWanConnTrigger(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanServiceList(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanCmo(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32* pulOut);
VOS_UINT32 ATP_WAN_GetWanAddrType(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanIpAddr(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanInterface(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanTunnelIfcName(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanIpv6Connstatus(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanConnstatus(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanIndex(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32 *pulOut);
VOS_UINT32 ATP_WAN_GetWanEnable(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32 *pulOut);
VOS_UINT32 ATP_WAN_GetWanPath(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR *pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanGateWay(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR *pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanDynamicDns(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR *pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanDnsServers(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR *pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanDnsOverride(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32 *pulOut);
VOS_UINT32 ATP_WAN_GetWanDnsEnabled(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32 *pulOut);
VOS_UINT32 ATP_WAN_GetWanMaxMtuSize(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32 *pulOut);
VOS_UINT32 ATP_WAN_GetWanConnType(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pcOut, VOS_UINT32 ulLen);
VOS_BOOL ATP_WAN_Judge_Connected(ATP_WAN_INFO_ST* pstWan);
VOS_BOOL ATP_WAN_Contain_Servicelist(ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pstServicelist);
VOS_BOOL ATP_WAN_Is_Same_Path(ATP_WAN_INFO_ST* pstOldWan, ATP_WAN_INFO_ST* pstNewWan);
VOS_CHAR* ATP_WAN_Get_Interface(ATP_WAN_INFO_ST* pstWan);
#ifdef SUPPORT_ATP_IPV6
VOS_UINT32 ATP_WAN_GetWanIpv4Enable(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32 *pulOut);
VOS_UINT32 ATP_WAN_GetWanIpv6Enable(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32 *pulOut);
VOS_UINT32 ATP_WAN_GetWanIpv6PrefixList(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR *pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanIpv6DynamicGateWay(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR *pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanIpv6MTUFlag(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32 *pulOut);
VOS_UINT32 ATP_WAN_GetWanIpv6AddrType(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR *pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanIpv6DnsOverride(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32 *pulOut);
VOS_UINT32 ATP_WAN_GetWanIpv6DynamicDns(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR *pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanIpv6DnsServers(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR *pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanIpv6Addr(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanIpv6DnsEnabled(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32 *pulOut);
VOS_UINT32 ATP_WAN_GetWanIpv6GateWay(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanIpv6RaPrefix(const ATP_WAN_INFO_ST* pstWan, VOS_CHAR* pcOut, VOS_UINT32 ulLen);
VOS_UINT32 ATP_WAN_GetWanIpv6RaPrefixLen(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32 *pulOut);
VOS_UINT32 ATP_WAN_GetWanIpv6PrefixLength(const ATP_WAN_INFO_ST* pstWan, VOS_UINT32 *pulOut);
VOS_BOOL ATP_WAN_Judge_Connected_Ipv6(ATP_WAN_INFO_ST* pstWan);
#endif

#ifdef SUPPORT_ATP_DT_WAN_PAGE
/*!
  \brief жû
  \param[in]  *pulIsFlag: 
  \return 
  \retval ATP_E_ERR_CFM_SHM_NOT_ATTACH ʼڴʧ
*/
VOS_UINT32 ATP_WAN_IfFactoryForFireWall(VOS_UINT32 *pulIsFlag);
#endif

#if defined(__cplusplus)
}
#endif

#endif

